/*
 *    Copyright 2004-2006 Intel Corporation
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

#ifndef __BPQ_CACHE_ENTRY__
#define __BPQ_CACHE_ENTRY__

#ifdef HAVE_CONFIG_H
#  include <dtn-config.h>
#endif

#include <oasys/debug/Log.h>

#include "Bundle.h"
#include "BundleRef.h"
#include "BundleList.h"

namespace dtn {

class Bundle;

class BPQCacheEntry : public oasys::Logger {
public:
	BPQCacheEntry() :
        Logger("BPQCacheEntry", "/dtn/bundle/bpq"),
        bundle_(new Bundle(), "cache_entry"),
        fragments_("cache_entry") {}

	int add_response(Bundle* bundle);
	int reassemble_fragments();

	/// accessors
	bool is_complete() 			{ return is_complete_; }
	BundleRef& bundle() 		{ return bundle_; }
	BundleList& fragment_list() { return fragments_; }



private:
	bool check_complete() const;

	bool is_complete_;		///<
	BundleRef  bundle_; 	///< The complete bundle
    BundleList fragments_;  ///< List of partial fragments
};

} // namespace dtn

#endif
